# Usage

## Initial setup

CRFs are always part of a study. So, create study as you would normally do, keep subject
identifier to ParticipantId, which is the default.

Once you do, you should enable CRF module. 
See [LabKey documentation][labkeyEnableModule] on how to enable a module.

In Study setup, select Edit additional properties. New fields should be:
- EudraCTNumber,
- StudySponsor,
- StudyCoordinator,
- RegulatoryNumber,
all as strings. It should look like this

![Alt text][studyParameters]


The initial set of setup lists is part of the distribution. Copy 
[archive][listArchive] locally 
and import list archive to Labkey in the study. You will get list of lists by
clicking on setup wheel at the top of the screen and selecting Manage lists.

Create demographicData dataset as part of the study. It can have no fields.

Add a tab (Wheel->Page Admin Mode, click on a + tab). Add CRF Portal web part. It should appear empty. This will show all forms that we will create.

## Setting up a form

Create a dataset as a list. Go to Wheel->Manage Lists and Create List. Setup fields as you would normally do. 
Three additional fields are required:

- participantCode (String)
- submissionDate (DateTime)
- crfRef (String)

[Here][exampleList] is an example included with the list archive. 

Open the inputLists list and add the name of the new list as a new entry. The sample
dataset is already there.

Open the Forms list. Add new entry. Some fields can only have the default value:

- formUrl: visit0
- reviewFormUrl: reviewVisit0
- viewURL: visit0.view

Form name can be any string, including spaces. Setup query is still to be created, but it
should name in Setup to distinguish it from others, say demographicsSetup. The last field, 
master query is to be set to the created dataset list. Master queries must contain
a participantCode field, and that is the field that will be used as the assignment field. The
sample Forms already has an entry for demographicsData.

Finally, create the setup list. It should contain the fields as the sample demographicsSetup,
shown in the image

![setup list][setupList]

The setup list can have multiple entries, which are combined to constitute a logical form.
The only programatical feature is that all datasets that are combined in the form
should be completed before the form is submitted for review. 

For a new setup list entry, set Query Name to the dataset list and Title can be any string. 
Other fields are set to NONE by default.

![setup list example with NONE][setupListExample1]

A more complex dataset layout might contain a sub-list, say list of medication, which
is enabled by a flag which is part of the dataset. The name
of the flag, which is a variable in the dataset, must be given as showFlag, the value
where list is to be filled is the showFlagValue, and showQuery is the sublist query which will
be shown, as the following example shows:

![setup list example][setupListExample]

## Filling the form

Add a tab (Wheel->Page Admin Mode, click on a + tab). Add CRF Portal web part. This will show all forms that we will create. If the setup
worked, the Demographics form should appears in the CRF tab. 

[studyParameters]: img/studyParametersSnapshot.png
[exampleList]: img/exampleListSnapshot.png
[listArchive]: setup/initialLists.zip
[labkeyEnableModule]: https://www.labkey.org/Documentation/wiki-page.view?name=enableModuleInFolder
[setupList]: img/setupList.png
[setupListExample]: img/exampleSetupList.png
[setupListExample1]: img/exampleSetupList1.png
